stages:
  - build
  - package

build-clang:
  image: $CI_REGISTRY/asxa86/images/ubuntu-gcc
  stage: build
  tags:
    - docker
    - shelley
  script:
    - apt install -y git make cmake python3
    - git clone https://github.com/llvm/llvm-project.git
    - cd llvm-project
    - git checkout tags/llvmorg-17.0.6 -b 17.0.6
    - cmake -S llvm -B build -G "Unix Makefiles"
      -DCMAKE_BUILD_TYPE=Release
      -DCMAKE_INSTALL_PREFIX=$CI_PROJECT_DIR/clang
      -DLLVM_ENABLE_PROJECTS="clang;clang-tools-extra;compiler-rt"
      -DLLVM_BUILD_LLVM_DYLIB=ON
      -DLLVM_LINK_LLVM_DYLIB=ON
      -DLLVM_TARGETS_TO_BUILD="host"
      -DGCC_INSTALL_PREFIX=/usr
    - cmake --build build --target all install --parallel $(nproc --all)
      
  artifacts:
    paths:
      - clang


build-ubuntu-clang:
  image: 
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  needs: ["build-clang"]
  stage: package
  tags:
    - docker
    - shelley
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:latest"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"
